﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Rebex.Net;
using Renci.SshNet;
namespace AutopayAutogate
{
    class Program
    {

        static void Main(string[] args)
        {
            /*
             *Please update to the configurations to either your sandbox or production details
             * 
             * */
            #region Please update this section
            String inputPIN = "0000";
            String inputPAN = "6280511000000095";
            String ExpiryDate = "1226";
            string terminalID = "3PSI0001";

            #endregion



            string[] SecureDataGeneratorList = new string[2];
            SecureDataGeneratorList = Utility.SecureDataGenerator(inputPAN, ExpiryDate, inputPIN);


            TimeSpan MySpan = new TimeSpan(15, 20, 30);

            //Calculate the first line row
            string batchReference = "PSI|" + Utility.RandomKeyGenerator() + "|" + Convert.ToString(MySpan.TotalSeconds);
            string batchDescription = "PSI Test Payment" + Utility.RandomKeyGenerator();
            Boolean isSingleDebit = true;
         
            //Add the generated row to an list
            List<string> firstRow = new List<string>();
            firstRow.Add(batchReference);
            firstRow.Add(batchDescription);
            firstRow.Add(isSingleDebit.ToString());
            firstRow.Add(terminalID);

            

            //Calculate the second line row
            string EncrptedData = (string)SecureDataGeneratorList.GetValue(0);
            string SourceAccountNumber = "0005276807";
            string SourceAccountType = "20";
            string BankCbnCode = "058";
            string EncrptedPIN = (string)SecureDataGeneratorList.GetValue(1);


            //You can connect to a database to get the records to upload to the SFTP. For the purpose of illustration, The data will be hosted in code using an array.
            string totalBeneficiaryCodes = "";
            long totalAmount = 0;
            string TotalbeneficiaryAccounts = "";


            string[,] PaymentList = new string[1, 11] {
                                                    {Utility.RandomKeyGenerator(),"50000","payment for test","12345232","em@il.com","058","0156426274","10","true","NGN","Adebiyi Paul"},
                                                     };

            for (int i = 0; i < PaymentList.GetLength(1); i++)
            {

                for (int y = 0; y < PaymentList.GetLength(0); y++)
                {// string s = PaymentList[i][];
                    totalAmount += Convert.ToInt64(PaymentList.GetValue(y, 1));
                    totalBeneficiaryCodes += PaymentList.GetValue(y, 3);
                    TotalbeneficiaryAccounts += PaymentList.GetValue(y, 6);
                }
                break;
            }



            int rowsOfPaymentList = PaymentList.GetLength(0);

            int totalRowsOfPaymentList = rowsOfPaymentList + 2; // The 2 represents the first two rows which are the Batch header information and Secure card data

            string Mac_Data = Utility.MacKeyGenerator(terminalID, totalBeneficiaryCodes, totalAmount, TotalbeneficiaryAccounts);

            //Add the generated row to an list
            List<string> secondRow = new List<string>();
            secondRow.Add(EncrptedData);
            secondRow.Add(SourceAccountNumber);
            secondRow.Add(SourceAccountType);
            secondRow.Add(BankCbnCode);
            secondRow.Add(EncrptedPIN);
            secondRow.Add(Mac_Data);

            string filename = Utility.RandomFilenameGenerator() + ".csv";
            using (CsvFileWriter writer = new CsvFileWriter(filename))
            {

                //Add the first Row
                CsvRow row = new CsvRow();
                for (int j = 0; j < firstRow.Count; j++)
                {
                    row.Add(String.Format("{0}", firstRow[j]));
                }
                // row.Add(Environment.NewLine);
                writer.WriteRow(row);

                //Add the second Row
                CsvRow row2 = new CsvRow();
                for (int j = 0; j < secondRow.Count; j++)
                {
                    row2.Add(String.Format("{0}", secondRow[j]));
                }
                //row.Add(Environment.NewLine);
                writer.WriteRow(row2);

                //Add the payment list
                CsvRow row3 = new CsvRow();
                CsvRow row4 = new CsvRow();

                for (int i = 0; i < PaymentList.GetLength(0); i++)
                {
                    for (int j = 0; j < PaymentList.GetLength(1); j++)
                    {
                        row3.Add(String.Format("{0}", PaymentList.GetValue(i, j)));
                        //row4.Add(String.Format("{0}", PaymentList.GetValue(i+1, j)));
                    }
                    ++i;

                }
                writer.WriteRow(row3);
                writer.WriteRow(row4);
            }


            //FileInfo f = new FileInfo("C://Users//babatunde.aluko//Documents//Visual Studio 2015//Projects//AutopayAutogate//AutopayAutogate//bin//Debug//" + filename);
            //string uploadfile = f.FullName;
            //Console.WriteLine(f.Name);
            //Console.WriteLine("uploadfile" + uploadfile);
            //var client = new SftpClient("172.35.2.21", 22, "kgc", "kgc654#");
            //client.Connect();
            //if (client.IsConnected)
            //{
            //    Console.WriteLine("I AM CONNECTED");
            //    var fileStream = new FileStream(uploadfile, FileMode.Open);
            //    if (fileStream != null)
            //    {
            //        Console.WriteLine("YOU ARE NOT NULL");

            //        client.UploadFile(fileStream, "/IN/" + f.Name, null);
            //        client.Disconnect();
            //        client.Dispose();

            //    //}

            //}

        }
    }
}